# System Configuration Files

During execution, Valohai provides ten configuration files at `/valohai/config/` containing execution metadata, parameters, inputs, and runtime information. These files are available in both JSON and YAML formats.

### Available Files

<table><thead><tr><th width="250.25">File</th><th width="455.25">Description</th></tr></thead><tbody><tr><td><strong>execution.json</strong><br><strong>execution.yaml</strong></td><td>Execution metadata (project, creator, environment)</td></tr><tr><td><strong>inputs.json</strong><br><strong>inputs.yaml</strong></td><td>Downloaded input files and metadata</td></tr><tr><td><strong>parameters.json</strong><br><strong>parameters.yaml</strong></td><td>Parameter values for the execution</td></tr><tr><td><strong>runtime.json</strong><br><strong>runtime.yaml</strong></td><td>Runtime environment information</td></tr><tr><td><strong>api.json</strong><br><strong>api.yaml</strong></td><td>Available API endpoints for the execution</td></tr></tbody></table>

### execution.json / execution.yaml

Contains execution-specific metadata including project information, creator details, environment configuration, and execution status.

#### Basic Execution Data

**JSON:**

```json
{
  "valohai.commit-identifier": "2db0b9da830749e462f0226a481559e0cf47292c",
  "valohai.creator-email": "drazen@valohai.com",
  "valohai.creator-id": 3323,
  "valohai.creator-name": "drazen",
  "valohai.environment-id": "0167d05d-a1d7-cc02-8256-6455a6ecfa56",
  "valohai.environment-name": "Microsoft Azure F2s v2 (No GPU)",
  "valohai.environment-slug": "azure-westeurope-f2sv2",
  "valohai.execution-counter": 6,
  "valohai.execution-ctime": "2025-06-07T18:49:43.984292+00:00",
  "valohai.execution-duration": null,
  "valohai.execution-id": "01974bba-352f-7c8c-d111-d8595a8649f2",
  "valohai.execution-image": "tensorflow/tensorflow:2.6.0",
  "valohai.execution-qtime": null,
  "valohai.execution-status": "created",
  "valohai.execution-step": "train-model",
  "valohai.execution-tags": [],
  "valohai.execution-title": null,
  "valohai.project-id": "0196c52a-528b-8d35-dd35-737aa5ae672b",
  "valohai.project-name": "Project/lovely-tensorflow"
}
```

**YAML:**

```yaml
valohai.commit-identifier: 2db0b9da830749e462f0226a481559e0cf47292c
valohai.creator-email: drazen@valohai.com
valohai.creator-id: 3323
valohai.creator-name: drazen
valohai.environment-id: 0167d05d-a1d7-cc02-8256-6455a6ecfa56
valohai.environment-name: Microsoft Azure F2s v2 (No GPU)
valohai.environment-slug: azure-westeurope-f2sv2
valohai.execution-counter: 6
valohai.execution-ctime: '2025-06-07T18:49:43.984292+00:00'
valohai.execution-duration: null
valohai.execution-id: 01974bba-352f-7c8c-d111-d8595a8649f2
valohai.execution-image: tensorflow/tensorflow:2.6.0
valohai.execution-qtime: null
valohai.execution-status: created
valohai.execution-step: train-model
valohai.execution-tags: []
valohai.execution-title: null
valohai.project-id: 0196c52a-528b-8d35-dd35-737aa5ae672b
valohai.project-name: Project/lovely-tensorflow

```

#### Extended Execution Data

When the execution is part of a task, pipeline, or triggered workflow, additional metadata is included:

**JSON:**

```json
{
  "valohai.task-id": "0192e1a3-c409-0021-c074-87370badadee",
  "valohai.task-counter": 124,
  "valohai.pipeline-id": "0192e1a4-33e3-6184-d308-0d87ab016111",
  "valohai.pipeline-counter": 1952,
  "valohai.pipeline-title": "Pathway to Production",
  "valohai.pipeline-node-id": "0192e1a7-fb19-e8c2-420c-bb53a1c0fc5d",
  "valohai.pipeline-tags": [
    "high-performance"
  ],
  "valohai.trigger-id": "0192e1a4-9332-6aaf-96ed-d78617a66ab2",
  "valohai.trigger-run-id": "0192e1a9-49a4-3efa-b8c0-a612a1e1456f",
  "valohai.trigger-title": "Webhook Automation"
}
```

**YAML:**

```yaml
valohai.task-id: 0192e1a3-c409-0021-c074-87370badadee
valohai.task-counter: 124
valohai.pipeline-id: 0192e1a4-33e3-6184-d308-0d87ab016111
valohai.pipeline-counter: 1952
valohai.pipeline-title: Pathway to Production
valohai.pipeline-node-id: 0192e1a7-fb19-e8c2-420c-bb53a1c0fc5d
valohai.pipeline-tags: ["high-performance"]
valohai.trigger-id: 0192e1a4-9332-6aaf-96ed-d78617a66ab2
valohai.trigger-run-id: 0192e1a9-49a4-3efa-b8c0-a612a1e1456f
valohai.trigger-title: Webhook Automation
```

### inputs.json / inputs.yaml

Lists all downloaded input files with their metadata, checksums, and file paths.

**JSON:**

```json
{
  "dataset": {
    "files": [
      {
        ## If file is selected using the cloud store URL
        ## e.g: azure://valohaidemo/mnist/preprocessed_mnist.npz
        "checksums": {
          "file_size": 12,
          "md5": "d3f9231518971c43c3e0fcf11666e88d",
          "sha1": "0d3d38ff5e5c2d0ead2486b769059b7cf895bf50",
          "sha256": "f55c2f6d1c89cdc26d5a51779deffcba8665531a0a83b557bc8fe43dae3cd118"
        },
        "download_intent": "always",
        "input_id": "01974bb9-016c-267c-61a6-8782103ecf2f",
        "name": "preprocessed_mnist.npz",
        "path": "/valohai/inputs/dataset/preprocessed_mnist.npz",
        "size": 22181444,
        "storage_uri": "azure://valohaidemo/mnist/preprocessed_mnist.npz",
        "uri": "azure://valohaidemo/mnist/preprocessed_mnist.npz"
      },
      {
        ## If file is selected using the datum ID, datum query or manually selected
        ## e.g: datum://019c0503-ad47-ba1e-9167-583aa21e8ef6
        "checksums": {
          "file_size": 13,
          "md5": "d3f9231518971c43c3e0fcf11666e88d",
          "sha1": "0d3d38ff5e5c2d0ead2486b769059b7cf895bf50",
          "sha256": "f55c2f6d1c89cdc26d5a51779deffcba8665531a0a83b557bc8fe43dae3cd118"
        },
        "download_intent": "always",
        "input_id": "01974bb9-016c-267c-61a6-8782103ecf2f",
        "datum_id": "019c0503-ad47-ba1e-9167-583aa21e8ef6",
        "name": "preprocessed_mnist_datum.npz",
        "path": "/valohai/inputs/dataset/preprocessed_mnist_datum.npz",
        "size": 22181222,
        "storage_uri": "azure://valohaidemo/mnist/preprocessed_mnist.npz",
        "uri": "datum://019c0503-ad47-ba1e-9167-583aa21e8ef6"
      }
    ],
    "input_id": "01974bb9-016c-267c-61a6-8782103ecf2f"
  }
}
```

**YAML:**

```yaml
dataset:
  files:
  ## If file is selected using the cloud store URL
  ## e.g: azure://valohaidemo/mnist/preprocessed_mnist.npz
  - checksums:
      file_size: 12
      md5: d3f9231518971c43c3e0fcf11666e88d
      sha1: 0d3d38ff5e5c2d0ead2486b769059b7cf895bf50
      sha256: f55c2f6d1c89cdc26d5a51779deffcba8665531a0a83b557bc8fe43dae3cd118
    download_intent: always
    input_id: 01974bb9-016c-267c-61a6-8782103ecf2f
    name: preprocessed_mnist.npz
    path: /valohai/inputs/dataset/preprocessed_mnist.npz
    size: 22181444
    storage_uri: azure://valohaidemo/mnist/preprocessed_mnist.npz
    uri: azure://valohaidemo/mnist/preprocessed_mnist.npz
  ## If file is selected using the datum ID, datum query or manually selected
  ## e.g: datum://019c0503-ad47-ba1e-9167-583aa21e8ef6
  - checksums:
      file_size: 13
      md5: d3f9231518971c43c3e0fcf11666e88d
      sha1: 0d3d38ff5e5c2d0ead2486b769059b7cf895bf50
      sha256: f55c2f6d1c89cdc26d5a51779deffcba8665531a0a83b557bc8fe43dae3cd118
    download_intent: always
    input_id: 01974bb9-016c-267c-61a6-8782103ecf2f
    datum_id: 019c0503-ad47-ba1e-9167-583aa21e8ef6
    name: preprocessed_mnist_datum.npz
    path: /valohai/inputs/dataset/preprocessed_mnist_datum.npz
    size: 22181222
    storage_uri: azure://valohaidemo/mnist/preprocessed_mnist_datum.npz
    uri: datum://019c0503-ad47-ba1e-9167-583aa21e8ef6
  input_id: 01974bb9-016c-267c-61a6-8782103ecf2f

```

### parameters.json / parameters.yaml

Contains parameter values defined for the execution.

**JSON:**

```json
{
  "epochs": 5,
  "learning_rate": 0.001,
  "batch_size": 32,
  "model_architecture": "resnet50"
}
```

**YAML:**

```yaml
epochs: 5
learning_rate: 0.001
batch_size: 32
model_architecture: resnet50
```

### runtime.json / runtime.yaml

Provides runtime environment information including runner identity and node details.

**JSON:**

```json
{
  "runner.identity": "azwesteuropef2sv2-hsygefxy",
  "runner.nodename": "azwesteuropef2sv2-hsygefxy"
}
```

**YAML:**

```yaml
runner.identity: azwesteuropef2sv2-hsygefxy
runner.nodename: azwesteuropef2sv2-hsygefxy
```

### api.json / api.yaml

Contains available API endpoints for the execution with authentication headers.

**JSON:**

```json
{
  "set_status_detail": {
    "method": "POST",
    "url": "https://app.valohai.com/api/v0/executions/018aa9d9-f899-8e4b-80f9-464ea1c855eb/set_status_detail/",
    "headers": {
      "Authorization": "Execution-Token {...}"
    }
  },
  "trigger_catalog": {
    "method": "POST",
    "url": "https://app.valohai.com/api/v0/worker-trigger-catalog/018aa9d9-f899-8e4b-80f9-464ea1c855eb/",
    "headers": {
      "Authorization": "Execution-Token {...}"
    }
  }
}
```

**YAML:**

```yaml
set_status_detail:
  method: POST
  url: https://app.valohai.com/api/v0/executions/018aa9d9-f899-8e4b-80f9-464ea1c855eb/set_status_detail/
  headers:
    Authorization: Execution-Token {...}
trigger_catalog:
  method: POST
  url: https://app.valohai.com/api/v0/worker-trigger-catalog/018aa9d9-f899-8e4b-80f9-464ea1c855eb/
  headers:
    Authorization: Execution-Token {...}
```

### File Access Examples

**Python (JSON):**

```python
import json

# Read parameters
with open("/valohai/config/parameters.json") as f:
    params = json.load(f)

# Read execution metadata
with open("/valohai/config/execution.json") as f:
    execution = json.load(f)

# Read input file information
with open("/valohai/config/inputs.json") as f:
    inputs = json.load(f)
```

**Python (YAML):**

```python
import yaml

# Read parameters
with open("/valohai/config/parameters.yaml") as f:
    params = yaml.safe_load(f)

# Read execution metadata
with open("/valohai/config/execution.yaml") as f:
    execution = yaml.safe_load(f)
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.valohai.com/executions/system-configuration-files.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
